# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
import urllib, urlparse
import re
from xml.dom.minidom import parseString
import youku

def httpget(url):
	try:
		file = urllib.urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def item(title, url, isFolder = True):
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urllib.urlencode({'url': url}), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/youku.php'
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误000')
		sys.exit(0)
	try:
		dom = parseString(content)
	except:
		xbmcgui.Dialog().ok('错误', '错误001')
		sys.exit(0)
	for element in dom.getElementsByTagName('item'):
		title = element.getElementsByTagName('title')[0].firstChild.nodeValue
		url = element.getElementsByTagName('url')[0].firstChild.nodeValue
		item(title, url)
	xbmcplugin.endOfDirectory(handle)
else:
	url = urlparse.parse_qs(urlparse.urlparse(sys.argv[2]).query)['url'][0]
	if re.match(r'http://www.youku.com/show_page/.*\.html', url):
		ret = youku.show_page(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'])
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'http://www.youku.com/show_episode/.*', url):
		ret = youku.show_episode(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'])
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'http://www.youku.com/playlist_show/.*\.html', url):
		ret = youku.playlist(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'])
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'http://list.youku.com/show/id.*', url):
		ret = youku.list_show_id(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'])
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'http://list.youku.com/show/episode.*', url):
		ret = youku.list_show_episode(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['item']:
				item(elem['title'], elem['url'])
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'http://v.youku.com/v_show/.*', url):
		ret = youku.play(url)
		if ret['success'] == False:
			xbmcgui.Dialog().ok('错误', '错误代码: ' + ret['code'])
		else:
			for elem in ret['url']:
				item(elem, 'stack://' + ' , '.join(ret['url'][elem]), False)
			xbmcplugin.endOfDirectory(handle)
	elif re.match(r'stack://.*', url):
		play('', url)
	else:
		xbmcgui.Dialog().ok('错误', '错误002')
